<?php
// ############################################################ //
//   Script pour Upload de fichier quelconque sur un serveur	//
// ############################################################ //
// Infos :														//
// -------														//
// Auteur : Fabien Guillod										//
// Email de l'auteur : f_guillod@bluewin.ch						//
// Date de cration : 8 mars 2005								//
// Dernire modification : 10 mars 2005							//
// Version : 1.0.0												//
// ############################################################ //
// Fonctionnement :												//
// ----------------												//
// 1. Test si l'utilisateur a choisi un fichier					//
// 2. Test si le fichier choisi est valide (si taille <> 0)		//
// 3. Test si le taille du fichier est infrieure  la taille	//
//    max														//
// 4. Test si l'extension est autorise.						//
// ############################################################ //
// Paramtrage :												//
// -------------												//
// Ce script peut facilement tre paramtr selon les besoins.	//
// Le paramtrage se fait principalement par la dfinition des	//
// variables globales. Voici les diffrentes variables :		//
//																//
//  - $DESTINATION_FOLDER : contient le rpertoire dans lequel	//
//    le fichier sera upload. Il est par dfaut rcupr du	//
//    formulaire, mais peut trs bien tre remplac par un url	//
//    en dur.													//
//																//
//  - $MAX_SIZE : spcifie la taille maximale que le fichier 	//
//    uploader peut avoir. Attention, le taille est spcifie	//
//    en octets.												//
//																//
//  - $RETURN_LINK : Rcupre automatiquement l'url de la page	//
//    web qui appelle ce script. Ce lien sert  crer des liens	//
//    de retour, qui sont toujours utiles.						//
//																//
//  - $AUTH_EXT : Ce tableau contient toutes les extensions qui	//
//    peuvent tre uploades. On peut en rajouter ou en			//
//    supprimer si besoin est.									//
// ############################################################ //

// ############################################################ //
// Dfinition des variable globales, modifiables  volont		//
// ############################################################ //
// Rcupration du dossier dans lequel le fichier sera upload	//
$DESTINATION_FOLDER = $_POST["folder"];							//
// Taille maximale de fichier, valeur en bytes					//
$MAX_SIZE = 20000000;											//
// Rcupration de l'url de retour								//
$RETURN_LINK = $_SERVER['HTTP_REFERER'];						//
// Dfinition des extensions de fichier autorises (avec le ".")//
$AUTH_EXT = array(".wav", ".xi", ".sf2", ".dls");	
										//
// ############################################################ //

// Fonction permettant de crer un lien de retour automatique

function createReturnLink(){
	global $RETURN_LINK;
	echo "<a href='".$RETURN_LINK."'>Retour</a><br>";
}

// Fonction permettant de vrifier si l'extension du fichier est
// autorise.

function isExtAuthorized($ext){
	global $AUTH_EXT;
	if(in_array($ext, $AUTH_EXT)){
		return true;
	}else{
		return false;
	}
}

// On vrifie que le champs contenant le chemin du fichier soit
// bien rempli.

if(!empty($_FILES["file"]["name"])){
	
	// Nom du fichier choisi:
	$nomFichier = $_FILES["file"]["name"] ;
	// Nom temporaire sur le serveur:
	$nomTemporaire = $_FILES["file"]["tmp_name"] ;
	// Type du fichier choisi:
	$typeFichier = $_FILES["file"]["type"] ;
	// Poids en octets du fichier choisit:
	$poidsFichier = $_FILES["file"]["size"] ;
	// Code de l'erreur si jamais il y en a une:
	$codeErreur = $_FILES["file"]["error"] ;
	// Extension du fichier
	$extension = strrchr($nomFichier, ".");
	
	// Si le poids du fichier est de 0 bytes, le fichier est
	// invalide (ou le chemin incorrect) => message d'erreur
	// sinon, le script continue.
	if($poidsFichier <> 0){
		// Si la taille du fichier est suprieure  la taille
		// maximum spcifie => message d'erreur
		if($poidsFichier < $MAX_SIZE){
			// On teste ensuite si le fichier a une extension autorise
			if(isExtAuthorized($extension)){
				// Ensuite, on copie le fichier upload ou bon nous semble.
				$uploadOk = move_uploaded_file($nomTemporaire, $DESTINATION_FOLDER.$nomFichier);
				if($uploadOk){
					echo("L'upload a russi !<br><br>");
					echo(createReturnLink());
				}else{
					echo("L'upload a chou !<br><br>");
					echo(createReturnLink());
				}
			}else{
				echo ("Les fichiers avec l'extension $extension ne peuvent pas tre uploads !<br>");
				echo (createReturnLink()."<br>");
			}
		}else{
			$tailleKo = $MAX_SIZE / 1000;
			echo("Vous ne pouvez pas uploader de fichiers dont la taille est suprieure  : $tailleKo Ko.<br>");
			echo (createReturnLink()."<br>");
		}		
	}else{
		echo("Le fichier choisi est invalide !<br>");
		echo (createReturnLink()."<br>");
	}
}else{
	echo("Vous n'avez pas choisi de fichier !<br>");
	echo (createReturnLink()."<br>");
}
?>